/* tzf31r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    int iter;
} zf31rr_;

#define zf31rr_1 zf31rr_

int main(void)
{
    /* Initialized data */
    static float root[3] = { 1.f,1.f,1.f };

    /* Local variables */
    static float beta[3], epsf;
    static int ierr;
    extern int zf31r_c(U_fp, float *, int *, float *, float *, int *,
                       float *, float *, int *, int *);
    static float epsx;
    static int n, nlead[3];
    static float alpha[9] /* was [3][3] */;
    static int itmax;
    extern int fun_c();

    n = 3;
    epsx = 1e-5f;
    epsf = 1e-5f;
    itmax = 30;
    zf31r_c((U_fp)fun_c, root, &n, &epsx, &epsf, &itmax, alpha, beta, nlead,
            &ierr);

    printf("\n %15.6e %15.6e %15.6e \n", root[0], root[1], root[2]);
    printf("\n %5i \n", zf31rr_1.iter);
    printf("\n %5i \n", ierr);
    return 0;
} /* main */

int fun_c(float *x, float *alpha, float *beta)
{
    /* System generated locals */
    float r__1;

    /* Builtin functions */
    double exp(double), sin(double), cos(double);

#define alpha_ref(a_1,a_2) alpha[(a_2)*3 + a_1]

    /* Parameter adjustments */
    --beta;
    alpha -= 4;
    --x;

    /* Function Body */
/* Computing 2nd power */
    r__1 = x[2] + x[3];
    beta[1] = -(x[1] + (float)exp(x[1] - 1) + r__1 * r__1 - 27);
/* Computing 2nd power */
    r__1 = x[3];
    beta[2] = -(x[1] * (float)exp(x[2] - 2) + r__1 * r__1 - 10);
/* Computing 2nd power */
    r__1 = x[2];
    beta[3] = -(x[3] + (float)sin(x[2] - 2) + r__1 * r__1 - 7);
    alpha_ref(1, 1) = (float)exp(x[1] - 1) + 1;
    alpha_ref(1, 2) = (x[2] + x[3]) * 2;
    alpha_ref(1, 3) = (x[2] + x[3]) * 2;
    alpha_ref(2, 1) = (float)exp(x[2] - 2);
    alpha_ref(2, 2) = x[1] * (float)exp(x[2] - 2);
    alpha_ref(2, 3) = x[3] * 2;
    alpha_ref(3, 1) = 0.f;
    alpha_ref(3, 2) = (float)cos(x[2] - 2) + x[2] * 2;
    alpha_ref(3, 3) = 1.f;
    return 0;
} /* fun_c */

#undef alpha_ref
